package awais.instagrabber.asyncs;

import android.os.AsyncTask;
import android.util.Log;

import androidx.annotation.NonNull;

import org.json.JSONArray;
import org.json.JSONObject;

import java.net.HttpURLConnection;
import java.net.URL;
import java.util.ArrayList;
import java.util.Collections;

import awais.instagrabber.interfaces.FetchListener;
import awais.instagrabber.models.CommentModel;
import awais.instagrabber.models.ProfileModel;
import awais.instagrabber.utils.Utils;

public class CommentsFetcher extends AsyncTask<Void, Void, CommentModel[]> {
    private final String shortCode;
    private final FetchListener<CommentModel[]> fetchListener;

    /*
     * i fucking spent the whole day on this and fixing all the fucking problems in this class.
     * DO NO FUCK WITH THIS CODE!
     *  -AWAiS (The Badak) @the.badak
     */
    public CommentsFetcher(final String shortCode, final FetchListener<CommentModel[]> fetchListener) {
        this.shortCode = shortCode;
        this.fetchListener = fetchListener;
    }

    @Override
    protected CommentModel[] doInBackground(final Void... voids) {
         /*
        "https://www.instagram.com/graphql/query/?query_hash=97b41c52301f77ce508f55e66d17620e&variables=" + "{\"shortcode\":\"" + shortcode + "\",\"first\":50,\"after\":\"" + endCursor + "\"}";

        97b41c52301f77ce508f55e66d17620e -> for comments
        51fdd02b67508306ad4484ff574a0b62 -> for child comments

        https://www.instagram.com/graphql/query/?query_hash=51fdd02b67508306ad4484ff574a0b62&variables={"comment_id":"18100041898085322","first":50,"after":""}
         */
        final ArrayList<CommentModel> commentModels = getParentComments();

        for (final CommentModel commentModel : commentModels) {
            final CommentModel[] childCommentModels = commentModel.getChildCommentModels();
            if (childCommentModels != null) {
                final int childCommentsLen = childCommentModels.length;

                final CommentModel lastChild = childCommentModels[childCommentsLen - 1];
                if (lastChild != null && lastChild.hasNextPage() && !Utils.isEmpty(lastChild.getEndCursor())) {
                    final CommentModel[] remoteChildComments = getChildComments(commentModel.getId());

//                    final int remoteCommentsLen = remoteChildComments.length;
//                    final CommentModel[] newChildComments = new CommentModel[childCommentsLen + remoteCommentsLen];
//                    System.arraycopy(remoteChildComments, 0, newChildComments, 0, remoteCommentsLen);
//                    System.arraycopy(childCommentModels, 0, newChildComments, remoteCommentsLen, childCommentsLen);
//                    commentModel.setChildCommentModels(newChildComments);

                    commentModel.setChildCommentModels(remoteChildComments);
                    lastChild.setPageCursor(false, null);
                }
            }
        }

        return commentModels.toArray(new CommentModel[0]);
    }

    @Override
    protected void onPreExecute() {
        if (fetchListener != null) fetchListener.doBefore();
    }

    @Override
    protected void onPostExecute(final CommentModel[] result) {
        if (fetchListener != null) fetchListener.onResult(result);
    }

    @NonNull
    private synchronized CommentModel[] getChildComments(final String commentId) {
        final ArrayList<CommentModel> commentModels = new ArrayList<>();

        String endCursor = "";
        while (endCursor != null) {
            final String url = "https://www.instagram.com/graphql/query/?query_hash=51fdd02b67508306ad4484ff574a0b62&variables=" +
                    "{\"comment_id\":\"" + commentId + "\",\"first\":50,\"after\":\"" + endCursor + "\"}";

            try {
                final HttpURLConnection conn = (HttpURLConnection) new URL(url).openConnection();
                conn.setUseCaches(false);
                conn.connect();

                if (conn.getResponseCode() != HttpURLConnection.HTTP_OK) break;
                else {
                    final JSONObject data = new JSONObject(Utils.readFromConnection(conn)).getJSONObject("data")
                            .getJSONObject("comment").getJSONObject("edge_threaded_comments");

                    final JSONObject pageInfo = data.getJSONObject("page_info");
                    endCursor = pageInfo.getString("end_cursor");
                    if (Utils.isEmpty(endCursor)) endCursor = null;

                    final JSONArray childComments = data.getJSONArray("edges");
                    final int length = childComments.length();

                    for (int i = 0; i < length; ++i) {
                        final JSONObject childComment = childComments.getJSONObject(i).getJSONObject("node");

                        final JSONObject owner = childComment.getJSONObject("owner");
                        final ProfileModel profileModel = new ProfileModel(false, false, owner.getString("id"),
                                owner.getString("username"), null, null, owner.getString("profile_pic_url"),
                                null, 0, 0, 0);

                        commentModels.add(new CommentModel(childComment.getString("id"), childComment.getString("text"),
                                childComment.getLong("created_at"),
                                childComment.has("edge_liked_by") ? childComment.getJSONObject("edge_liked_by").getLong("count") : 0,
                                profileModel));
                    }
                }
            } catch (final Exception e) {
                Log.e("AWAISKING_APP", "", e);
                break;
            }
        }

        return commentModels.toArray(new CommentModel[0]);
    }

    @NonNull
    private synchronized ArrayList<CommentModel> getParentComments() {
        final ArrayList<CommentModel> commentModelsList = new ArrayList<>();

        String endCursor = "";
        while (endCursor != null) {
            final String url = "https://www.instagram.com/graphql/query/?query_hash=97b41c52301f77ce508f55e66d17620e&variables=" +
                    "{\"shortcode\":\"" + shortCode + "\",\"first\":50,\"after\":\"" + endCursor + "\"}";

            try {
                final HttpURLConnection conn = (HttpURLConnection) new URL(url).openConnection();
                conn.setUseCaches(false);
                conn.connect();

                if (conn.getResponseCode() != HttpURLConnection.HTTP_OK) break;
                else {
                    final JSONObject parentComments = new JSONObject(Utils.readFromConnection(conn)).getJSONObject("data")
                            .getJSONObject("shortcode_media").getJSONObject("edge_media_to_parent_comment");

                    final JSONObject pageInfo = parentComments.getJSONObject("page_info");
                    endCursor = pageInfo.getString("end_cursor");

                    final boolean containsToken = endCursor.contains("bifilter_token");
                    if (!Utils.isEmpty(endCursor) && containsToken && endCursor.contains("cached_comments_cursor")) {
                        final JSONObject endCursorObject = new JSONObject(endCursor);
                        endCursor = "{\\\"cached_comments_cursor\\\": \\\"" + endCursorObject.getString("cached_comments_cursor") +
                                "\\\", \\\"bifilter_token\\\": \\\"" + endCursorObject.getString("bifilter_token") + "\\\"}";
                    } else if (containsToken) endCursor = null;

                    final JSONArray comments = parentComments.getJSONArray("edges");
                    final int commentsLen = comments.length();
                    final CommentModel[] commentModels = new CommentModel[commentsLen];

                    for (int i = 0; i < commentsLen; ++i) {
                        final JSONObject comment = comments.getJSONObject(i).getJSONObject("node");

                        final JSONObject owner = comment.getJSONObject("owner");
                        final ProfileModel profileModel = new ProfileModel(false, owner.getBoolean("is_verified"), owner.getString("id"),
                                owner.getString("username"), null, null, owner.getString("profile_pic_url"),
                                null, 0, 0, 0);

                        final String commentId = comment.getString("id");
                        commentModels[i] = new CommentModel(commentId, comment.getString("text"), comment.getLong("created_at"),
                                comment.has("edge_liked_by") ? comment.getJSONObject("edge_liked_by").getLong("count") : 0,
                                profileModel);

                        if (comment.has("edge_threaded_comments")) {
                            final JSONObject childComments = comment.getJSONObject("edge_threaded_comments");
                            final JSONArray childCommentsArray = childComments.getJSONArray("edges");
                            final int childCommentsLen = childCommentsArray.length();
                            if (childCommentsLen > 0) {
                                final CommentModel[] childCommentModels = new CommentModel[childCommentsLen];
                                final JSONObject childPageInfo = childComments.getJSONObject("page_info");
                                final String childEndCursor = childPageInfo.getString("end_cursor");

                                for (int j = 0; j < childCommentsLen; ++j) {
                                    final JSONObject childComment = childCommentsArray.getJSONObject(j).getJSONObject("node");

                                    final JSONObject childOwner = childComment.getJSONObject("owner");
                                    final ProfileModel childProfileModel = new ProfileModel(false, false, childOwner.getString("id"),
                                            childOwner.getString("username"), null, null, childOwner.getString("profile_pic_url"),
                                            null, 0, 0, 0);

                                    childCommentModels[j] = new CommentModel(childComment.getString("id"),
                                            childComment.getString("text"), childComment.getLong("created_at"),
                                            childComment.has("edge_liked_by") ? childComment.getJSONObject("edge_liked_by").getLong("count") : 0,
                                            childProfileModel);
                                }

                                childCommentModels[childCommentsLen - 1].setPageCursor(childPageInfo.getBoolean("has_next_page"), childEndCursor);
                                commentModels[i].setChildCommentModels(childCommentModels);
                            }
                        }
                    }

                    Collections.addAll(commentModelsList, commentModels);
                }
            } catch (final Exception e) {
                Log.e("AWAISKING_APP", "", e);
                break;
            }
        }

        return commentModelsList;
    }
}
