package awais.instagrabber.models;

import java.io.Serializable;

public abstract class BasePostModel implements Serializable {
    protected String postId;
    protected String displayUrl;
    protected String shortCode;
    protected String postCaption;
    protected boolean isVideo;
    protected long timestamp;

    public final boolean isVideo() {
        return isVideo;
    }

    public final String getPostId() {
        return postId;
    }

    public final String getDisplayUrl() {
        return displayUrl;
    }

    public final String getPostCaption() {
        return postCaption;
    }

    public final String getShortCode() {
        return shortCode;
    }

    public final long getTimestamp() {
        return timestamp;
    }
}