package awais.instagrabber.models;

public final class ClipModel {
    private final boolean post;
    private final String text;
    private final String caption;

    public ClipModel(final boolean post, final String text) {
        this.post = post;
        this.text = text;
        this.caption = "A " + (post ? "post link" : "username") + " has been copied to clipboard!\nTap here to view it.";
    }

    public boolean isPost() {
        return post;
    }

    public String getText() {
        return text;
    }

    public String getInfoCaption() {
        return caption;
    }
}